Summary:	Creates an initial ramdisk image for preloading modules
Summary(pl.UTF-8):	Narzędzie do tworzenia inicjalnego ramdysku używanego przy starcie systemu
Name:		geninitrd
Version:	12821
Release:	1
License:	GPL
Group:		Applications/System
Source0:	%{name}-%{version}.tar.gz
# Source0-md5:	8b4333782f37af8d56ecd3a9d153e164
Patch0:		%{name}-static-dev.patch
Patch1:		%{name}-posix-sh.patch
URL:		http://git.pld-linux.org/?p=projects/geninitrd.git
BuildRequires:	xmlto >= 0:0.0.18-1
Requires:	/usr/bin/ldd
Requires:	awk
Requires:	busybox-implementation >= 1.30.0-1
Requires:	coreutils
Requires:	cpio
Requires:	fileutils
Requires:	glibc-misc
Requires:	gzip
Requires:	libgcc
Requires:	mktemp >= 1.5-8
Requires:	mount
Requires:	pci-database >= 0.4
Requires:	rc-scripts >= 0.2.7
Requires:	tar
Requires:	virtual(module-tools)
Requires:	xz
Suggests:	genromfs
Suggests:	pciutils
Obsoletes:	mkinitrd
# suggest for blkid
%if "%{pld_release}" == "ac"
# otherwise LVM subsystem is not enabled in geninitrd
Suggests:	lvm2-initrd
# without this softraid installations of PLD fail
Suggests:	mdadm-initrd >= 1.12.0-1
Conflicts:	grubby < 5.0.4-3.1
%else
Conflicts:	grubby < 6.0.24-3
%endif
Conflicts:	busybox-initrd < 1.35.0-3
Conflicts:	kmod < 7-2
Conflicts:	module-init-tools < 3.2.2-6
Conflicts:	pciutils < 2.2.9
Conflicts:	udev-initrd < 1:168
Conflicts:	xz < 4.999.9
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Geninitrd creates filesystem images for use as initial ramdisk
(initrd) images. These ramdisk images are often used to preload the
block device modules (SCSI or RAID) needed to access the root
filesystem.

In other words, generic kernels can be built without drivers for any
SCSI adapters which load the SCSI driver as a module. Since the kernel
needs to read those modules, but in this case it isn't able to address
the SCSI adapter, an initial ramdisk is used. The initial ramdisk is
loaded by the operating system loader (normally LILO) and is available
to the kernel as soon as the ramdisk is loaded. The ramdisk image
loads the proper SCSI adapter and allows the kernel to mount the root
filesystem. The geninitrd program creates such a ramdisk using
information found in the /etc/modules.conf file.

%description -l pl.UTF-8
Geninitrd służy do tworzenia obrazu systemu plikowego używanego jako
inicjalny ramdysk (initrd), z którego przy starcie systemu są ładowane
moduły kernela z obsługą urządzeń których obsługa nie jest
wkompilowana w kernel. Zazwyczaj modułami ładowanymi z inicjalnego
systemu plikowego są sterowniki SCSI, IDE czy też RAID po to żeby w
dalszej części inicjacji systemu był możliwy dostęp do głównego
systemu plikowego (root fs).

Dzięki initrd jest możliwe używanie dystrybucyjnego kernela w którym
wkompilowana jest minimalna ilość obsługi różnych urządzeń, a reszta
kodu obsługi sterowników SCSI, IDE czy RAID jest doczytywana w trakcie
startu z initrd. Skrypt geninitrd generuje obraz ramdysku na podstawie
bieżących informacji zawartych w /etc/modules.conf.

%prep
%setup -q
%patch0 -p1
%patch1 -p1

%build
%{__make}

%install
rm -rf $RPM_BUILD_ROOT
%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc ChangeLog
%config(noreplace) %verify(not md5 mtime size) /etc/sysconfig/geninitrd
%attr(755,root,root) /sbin/geninitrd
%{_mandir}/man8/geninitrd.8*

%dir /lib/geninitrd
/lib/geninitrd/functions
/lib/geninitrd/functions.initrd
/lib/geninitrd/mod-*.sh
%attr(755,root,root) /lib/geninitrd/extract-ikconfig

%dir /lib/geninitrd/udev-rules
/lib/geninitrd/udev-rules/*.rules
%changelog
* Tue Jun 20 2023 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/geninitrd.git;a=log;h=master

* Tue Jun 20 2023 Jan Palus <atler@pld-linux.org> e32c608
- up to 12821

* Sat Nov 12 2022 Jan Palus <atler@pld-linux.org> 4858183
- pull C: busybox-initrd out of ac condition; rel 3

* Sat Nov 12 2022 Jan Palus <atler@pld-linux.org> 2d549cd
- C: busybox-initrd without mountpoint applet; rel 2

* Mon Nov 07 2022 Jan Palus <atler@pld-linux.org> 585ddd2
- up to 12818

* Sun Aug 22 2021 Arkadiusz Miśkiewicz <arekm@maven.pl> dbb71e1
- Rel 10; cbc in pld 5.13 kernel is built-in, so handle that (fixes case when rootfs is on LUKS)

* Sat Dec 26 2020 Arkadiusz Miśkiewicz <arekm@maven.pl> 5dbbb84
- rel 9; swsusp was breaking normal setups; fix that

* Tue Nov 17 2020 Arkadiusz Miśkiewicz <arekm@maven.pl> 29c29ce
- rel 8; update from git

* Thu Mar 26 2020 mis <mis@pld-linux.org> 7a10446
- swsusp as separate geninird module

* Tue Mar 24 2020 mis <mistoo@gmail.com> 11e97b6
- added swsusp support patch

* Tue Nov 26 2019 Arkadiusz Miśkiewicz <arekm@maven.pl> 3dd63e3
- rel 6; correct patch order

* Mon Nov 25 2019 Arkadiusz Miśkiewicz <arekm@maven.pl> e48d916
- rel 5; add fixes from git

* Wed May 15 2019 Arkadiusz Miśkiewicz <arekm@maven.pl> bd24739
- rel 4; add cpu microcode to initrd images when lilo in use

* Thu Jan 24 2019 Arkadiusz Miśkiewicz <arekm@maven.pl> eb86b90
- rel 3; force busybox with getopts support

* Thu Jan 24 2019 Arkadiusz Miśkiewicz <arekm@maven.pl> e916196
- R: libgcc because geninitrd installs libgcc_s.so.1.

* Tue Dec 18 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 3a06c81
- rel 2; new git commits

* Tue Dec 18 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 14222db
- up to 12787

* Tue Aug 14 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 7dbbcc6
- rel 10; update from git

* Fri Aug 10 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> ce25c10
- rel 8; silence ramdisk_size warning for initramfs

* Fri May 04 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 59e121d
- rel 8; ext4 drags in libcrc32c stuff

* Tue Jun 21 2016 Jakub Bogusz <qboosh@pld-linux.org> 89be020
- added static-dev patch (don't force devtmpfs if udev is disabled in target system)
- added posix-sh patch (don't use non-POSIX ${ / / } extension)
- release 7

